#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const config_1 = require("./config");
const data_source_1 = require("./data_source");
const index_1 = require("./generated/index");
const service_common_1 = require("@crosslab/service-common");
data_source_1.AppDataSource.initialize()
    .then(() => {
    index_1.app.get('/federation/status', (_req, res) => {
        res.send({ status: 'ok' });
    });
    index_1.app.initService({
        security: {
            JWT: (0, service_common_1.JWTVerify)(config_1.config)
        }
    });
    index_1.app.listen(config_1.config.PORT);
})
    .catch((err) => {
    console.error('Error during Data Source initialization:', err);
});
//# sourceMappingURL=index.js.map