"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatInstitution = void 0;
const utils_1 = require("./utils");
/**
 * This function formats a {@link InstitutionModel} to a {@link Institution}.
 * @param institutionModel The {@link InstitutionModel} to be formatted.
 * @returns The resulting {@link Institution}.
 */
function formatInstitution(institutionModel) {
    return {
        name: institutionModel.name,
        api: institutionModel.api,
        url: (0, utils_1.institutionUrlFromId)(institutionModel.uuid),
        homepage: institutionModel.homepage,
        federatedApi: institutionModel.federatedApi,
    };
}
exports.formatInstitution = formatInstitution;
//# sourceMappingURL=format.js.map